﻿using Modèle;
using Persistance;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Business
{
    public class ManagerUsers
    {
        public List<Personne> Utilisateurs { get; private set; }
        public Personne SelectedUser { get; set; }

        /// <summary>
        ///  DéPENDANCE
        /// </summary>

        public IPersistanceManager Pers { get; set; }

        /// <summary>
        /// constructeur avec INJECTION DE LA DéPENDANCE
        /// </summary>

        public ManagerUsers(IPersistanceManager pers)
        {
            Utilisateurs = new List<Personne>();
            Pers = pers;
        }
        public void LoadUsers()
        {
            Utilisateurs.Clear();
            Utilisateurs.AddRange(Pers.LoadUsers());
            SelectedUser = null;
        }

        public void SaveUsers()
        {
            Pers.SaveUsers(Utilisateurs);
        }

        public bool AjouterUtilisateur(Personne user)
        {
            if (Utilisateurs.Contains(user))
            {
                return false;

            }
            Utilisateurs.Add(user);
            return true;
        }

        public bool SupprimerUtilisateur(Personne user)
        {
            if (!Utilisateurs.Contains(user))
            {
                return false;
            }
            Utilisateurs.Remove(user);
            return true;
        }

        public Personne GetUtilisateur(Personne user)
        {
            return Utilisateurs.SingleOrDefault(r => r.Equals(user));
        }

        public bool ModifieUtilisateur(Personne oldU, Personne newU)
        {
            if (!oldU.Equals(newU))
            {
                return false;
            }
            Utilisateurs.Remove(oldU);
            Utilisateurs.Add(newU);
            return true;
        }


    }
}
